/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
namespace df {
  struct DFHACK_EXPORT crime {
    int32_t id;
    enum T_mode : int32_t {
      ProductionOrderViolation, // 0, 0x0
      ExportViolation, // 1, 0x1
      JobOrderViolation, // 2, 0x2
      ConspiracyToSlowLabor, // 3, 0x3
      Murder, // 4, 0x4
      DisorderlyBehavior, // 5, 0x5
      BuildingDestruction, // 6, 0x6
      Vandalism, // 7, 0x7
      Theft, // 8, 0x8
      Robbery, // 9, 0x9
      BloodDrinking, // 10, 0xA
      /**
       * Since v0.47.01
       */
      Embezzlement, // 11, 0xB
      /**
       * Since v0.47.01
       */
      AttemptedMurder, // 12, 0xC
      /**
       * Since v0.47.01
       */
      Kidnapping, // 13, 0xD
      /**
       * Since v0.47.01
       */
      AttemptedKidnapping, // 14, 0xE
      /**
       * Since v0.47.01
       */
      AttemptedTheft, // 15, 0xF
      /**
       * Since v0.47.01
       */
      Treason, // 16, 0x10
      /**
       * Since v0.47.01
       */
      Espionage, // 17, 0x11
      /**
       * Since v0.47.01
       */
      Bribery, // 18, 0x12
    };
    T_mode mode;
    struct DFHACK_EXPORT T_punishment {
      int32_t hammerstrikes;
      int32_t prison_time;
      int32_t give_beating;
      static struct_identity _identity;
    public:
      T_punishment();
    };
    T_punishment punishment;
    int32_t criminal;
    int32_t criminal_hf;
    int32_t criminal_hf_2; /*!< the two additional copies probably refers to some other roles, but all 3 are identical in cases seen */
    int32_t criminal_hf_3;
    int32_t unk_v47_4;
    int32_t unk_v47_5;
    int32_t unk_v47_6;
    int32_t unk_v47_7;
    int32_t unk_v47_8;
    int32_t unk_v47_9;
    int32_t unk_v47_10;
    int32_t convicted;
    int32_t unk_v47_11;
    int32_t convicted_hf;
    int32_t convicted_hf_2; /*!< the two additional copies probably refers to some other roles, but all 3 are identical in cases seen */
    int32_t convicted_hf_3;
    int32_t unk_v47_15;
    int32_t unk_v47_16;
    int32_t unk_v47_17;
    int32_t unk_v47_18;
    int32_t unk_v47_19;
    int32_t unk_v47_20;
    int32_t unk_v47_21;
    int32_t victim;
    int32_t unk_v47_22;
    int32_t victim_hf;
    int32_t victim_hf_2; /*!< the two additional copies probably refers to some other roles, but all 3 are identical in cases seen */
    int32_t victim_hf_3;
    int32_t unk_v47_26;
    int32_t unk_v47_27;
    int32_t unk_v47_28;
    int32_t unk_v47_29;
    int32_t unk_v47_30;
    int32_t unk_v47_31;
    int32_t unk_v47_32;
    union T_flags {
      uint32_t whole;
      struct {
        uint32_t sentenced : 1;
        uint32_t discovered : 1;
        uint32_t needs_trial : 1; /*!< i.e. the player chooses whom to convict */
      } bits;
      enum Shift {
        shift_sentenced = 0,
        shift_discovered = 1,
        shift_needs_trial = 2
      };
      enum Mask : uint32_t {
        mask_sentenced = 0x1U,
        mask_discovered = 0x2U,
        mask_needs_trial = 0x4U
      };
      T_flags(uint32_t whole_ = 0) : whole(whole_) {};
    };
    T_flags flags;
    int32_t incident_id;
    int32_t event_year;
    int32_t event_time;
    int32_t discovered_year;
    int32_t discovered_time;
    int32_t site;
    int32_t entity;
    int32_t item_id; /*!< seen with crime of theft */
    struct DFHACK_EXPORT T_reports {
      int32_t death_id;
      int32_t crime_id;
      int32_t unk1; /*!< unk1 of witness_reports; 1 = found body? */
      int32_t event_year;
      int32_t event_time;
      int32_t witness;
      int32_t accuses;
      int32_t report_year;
      int32_t report_time;
      static struct_identity _identity;
    public:
      T_reports();
    };
    std::vector<T_reports* > reports;
    struct DFHACK_EXPORT T_counterintelligence {
      int32_t unk_1; /*!< suspect entity, as counterintelligence shows organization unknown for examined cases */
      int32_t identified_hf;
      int32_t identified_2; /*!< same as the one above only one seen (in 3 cases...). */
      static struct_identity _identity;
    public:
      T_counterintelligence();
    };
    std::vector<T_counterintelligence* > counterintelligence; /*!< since 0.47.01 */
    static struct_identity _identity;
    typedef crime* key_pointer_type;
    typedef int32_t key_field_type;
    static int binsearch_index(const std::vector<crime*> &vec, key_field_type key, bool exact = true);
    static int binsearch_index(const std::vector<crime*> &vec, key_pointer_type key, bool exact = true);
    static std::vector<crime*> &get_vector();
    static std::vector<crime*> *get_vector_ptr();
    static crime *find(key_field_type id);
  public:
    crime();
  };
  template<> struct DFHACK_EXPORT identity_traits<crime::T_mode> {
    static enum_identity identity;
    static enum_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT enum_traits<crime::T_mode> {
    static const bool is_complex = false;
    typedef int32_t base_type;
    typedef crime::T_mode enum_type;
    static const base_type first_item_value = 0;
    static const base_type last_item_value = 18;
    static inline bool is_valid(base_type value) {
      return (value >= first_item_value && value <= last_item_value);
    }
    static const enum_type first_item = (enum_type)first_item_value;
    static const enum_type last_item = (enum_type)last_item_value;
    static const char *const key_table[19];
  };
  template<> struct DFHACK_EXPORT bitfield_traits<crime::T_flags> {
    typedef uint32_t base_type;
    typedef crime::T_flags bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<crime::T_flags> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
}
